unit GoodsF;

interface

uses Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
     StdCtrls, SohoComb, SoCtrls, SohoBtns, SohoRgst, SoCtmRgs, SoCtmCmb;

type
  TGoodsForm = class(TForm)
    sohoLabel6: TsohoLabel;
    sohoLabel1: TsohoLabel;
    OkB: TsohoBitBtn;
    CancelB: TsohoBitBtn;
    NameE: TsohoEdit;
    UnitsC: TsohoDBComboBox;
    Reg: TsohoSubRegister;
    procedure NameEModify(Sender: TObject; OldValue, NewValue: String);
    procedure UnitsCChange(Sender: TObject);
    procedure NameECanExit(Sender: TObject; var AllowExit: Boolean);
  private
    { Private declarations }
    function SaveGoods : boolean;
    function EditGoods (IdGoods : LongInt) : boolean;
    function NewGoods  (IdGoods, IdGrp, Hash : LongInt) : boolean;
  public
    { Public declarations }
    Modified : boolean;
    InsertMode : boolean;
    aIdGoods, aIdGrp, aHash : LongInt;
  end;

var GoodsForm: TGoodsForm;

function EditGoods (IdGoods : LongInt) : boolean;
function NewGoods  (IdGoods, IdGrp, Hash : LongInt) : boolean;

implementation
uses SoUtils, SoDbRtn, Db, DBTables, Global, SoBDERtn;

{$R *.DFM}
function EditGoods (IdGoods : LongInt) : boolean;
begin
  try
    if GoodsForm = nil then GoodsForm := TGoodsForm.Create(Application);
    Result := GoodsForm.EditGoods(IdGoods);
  except
    GoodsForm.Free;
    GoodsForm := nil;
  end;
end;

function NewGoods  (IdGoods, IdGrp, Hash : LongInt) : boolean;
begin
  try
    if GoodsForm = nil then GoodsForm := TGoodsForm.Create(Application);
    Result := GoodsForm.NewGoods(IdGoods, IdGrp, Hash);
  except
    GoodsForm.Free;
    GoodsForm := nil;
  end;
end;

function TGoodsForm.SaveGoods : boolean;
begin
  if InsertMode then
    Result := ExecuteSQL(Reg.PathToSQL+'_.sql', BaseDir,
      [IntToStr(aIdGoods), IntToStr(aIdGrp), IntToStr(aHash), NameE.AsString,
       IntToStr(UnitsC.ItemId)])
  else
    Result := ExecuteSQL(Reg.PathToSQL+'_.sql', BaseDir,
      [IntToStr(aIdGoods), NameE.AsString, IntToStr(UnitsC.ItemId)])
end;

function TGoodsForm.EditGoods (IdGoods : LongInt) : boolean;
var Query : TQuery;
begin
 Result := false;
 aIdGoods := IdGoods;
 Query := GetQuery(Reg.PathToSQL+'___Id.sql', BaseDir,
  [IntToStr(aIdGoods)]);
 if Query = nil then begin
   ErrorMsg('  . !');
   exit;
 end;
 if not UnitsC.Active then UnitsC.Activate;
 NameE.AsString := Query.FieldByName('Name').AsString;
 UnitsC.ItemId := Query.FieldByName('IdUnits').AsInteger;
 Modified := false;
 OkB.Enabled := false;
 InsertMode := false;
 Result := ShowModal = mrOk;
 if not Result then exit;
 SaveGoods;
end;

function TGoodsForm.NewGoods  (IdGoods, IdGrp, Hash : LongInt) : boolean;
begin
 aIdGoods := IdGoods;
 aIdGrp   := IdGrp;
 aHash    := Hash;
 Result := false;
 if not UnitsC.Active then UnitsC.Activate;
 NameE.AsString := '';
 Modified := false;
 OkB.Enabled := false;
 InsertMode := true;
 Result := ShowModal = mrOk;
 if not Result then exit;
 SaveGoods;
end;

procedure TGoodsForm.NameEModify(Sender: TObject; OldValue,
  NewValue: String);
begin
 Modified := true;
 OkB.Enabled := true;
end;

procedure TGoodsForm.UnitsCChange(Sender: TObject);
begin
 Modified := true;
 OkB.Enabled := true;
end;

procedure TGoodsForm.NameECanExit(Sender: TObject; var AllowExit: Boolean);
begin
 AllowExit := AllowExit or (ActiveControl = CancelB);
end;

initialization
  GoodsForm := nil;
end.
