unit KnoF;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, SohoComb, Mask, ToolEdit, CurrEdit, SoCtrls, SohoBtns,
  ExtCtrls, Grids, SoDBGrid, Placemnt, SoRxTls, SoBckgrd, SoClass, SoFolder,
  DBTables, Db, SohoRgst, ComCtrls, SoExlRep, SoCtmFld, SoCtmRgs, DBGrids,
  RXDBCtrl, SoCtmCmb;

type
  TKnoForm = class(TForm)
    sohoLabel1: TsohoLabel;
    KnoNumberE: TsohoEdit;
    sohoLabel2: TsohoLabel;
    sohoLabel3: TsohoLabel;
    KnoDateE: TsohoEdit;
    SummE: TCurrencyEdit;
    sohoLabel4: TsohoLabel;
    CompanyC: TsohoDBComboBox;
    OkB: TsohoBitBtn;
    CancelB: TsohoBitBtn;
    SetSummB: TsohoBitBtn;
    Back: TsohoBackground;
    Ini: TsohoFormStorage;
    PosSource: TDataSource;
    MoneySource: TDataSource;
    SubReg: TsohoSubRegister;
    PosT: TTable;
    MoneysT: TTable;
    PosQ: TQuery;
    MoneysQ: TQuery;
    PosFolder: TsohoFolder;
    MoneyFolder: TsohoFolder;
    PageControl1: TPageControl;
    KNOPage: TTabSheet;
    AssessmentPage: TTabSheet;
    sohoLabel5: TsohoLabel;
    PosGrid: TsohoDBGrid;
    sohoLabel6: TsohoLabel;
    MoneyGrid: TsohoDBGrid;
    sohoLabel7: TsohoLabel;
    PosSummE: TCurrencyEdit;
    sohoLabel9: TsohoLabel;
    CurSummE: TCurrencyEdit;
    sohoLabel11: TsohoLabel;
    sohoLabel12: TsohoLabel;
    MoneysSummE: TCurrencyEdit;
    RemainE: TCurrencyEdit;
    PrintB: TsohoBitBtn;
    Reporter: TsohoExcelReporter;
    procedure SetSummBClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    function PosGridOperation(Sender: TObject;
      Operation: TsohoGridOperation): Boolean;
    function MoneyGridOperation(Sender: TObject;
      Operation: TsohoGridOperation): Boolean;
    procedure FormShow(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure PrintBClick(Sender: TObject);
    procedure ReporterAfterTransfer(Sender: TObject; var Allow: Boolean);
  private
    { Private declarations }
    function  InsertNewPos : boolean;
    function  InsertNewFactory : boolean;
    procedure RecalcPosSumm (Sender :  TField);
    procedure RecalcMoneySumm (Sender :  TField);
    function  EditKNO (IdKNO : LongInt) : boolean;
    function  NewKNO : boolean;
    procedure SaveKNO;
    procedure PrepareForm;
  public
    { Public declarations }
    Modifyed : boolean;
    EditMode : boolean;
    FIdKNO   : LongInt;
    AddedIds, AddedFactory : TsohoIntegerList;
    DelIds, DelFactory : TsohoIntegerList;
  end;

var KnoForm: TKnoForm;

function EditKNO (IdKNO : LongInt) : boolean;
function NewKNO : boolean;

implementation
uses Global, SoDBRtn, SoUtils, Main, SoUnit, SoDate, SoExRepD, SoBDERtn;

{$R *.DFM}

function EditKNO (IdKNO : LongInt) : boolean;
begin
  try
   if KnoForm = nil then KnoForm := TKnoForm.Create(Application);
   Result := KnoForm.EditKNO(IdKNO);
  except
    KnoForm.Free;
    KnoForm := nil;
  end;
end;

function NewKNO : boolean;
begin
  try
   if KnoForm = nil then KnoForm := TKnoForm.Create(Application);
   Result := KnoForm.NewKNO;
  except
    KnoForm.Free;
    KnoForm := nil;
  end;
end;

procedure TKnoForm.PrepareForm;
var TmpQuery : TQuery;
begin
  AddedIds.Clear;
  AddedFactory.Clear;
  DelIds.Clear;
  DelFactory.Clear;
  PosT.Close;
  MoneysT.Close;

  PosSummE.Value := 0;
  CurSummE.Value := 0;
  MoneysSummE.Value := 0;
  RemainE.Value := 0;

  ExecuteSQL(SubReg.PathToSQL+'___.sql',
     SubReg.PathToProgram+'TempTables\', NillParams);
  ExecuteSQL(SubReg.PathToSQL+'___.sql',
     SubReg.PathToProgram+'TempTables\', NillParams);
  PosT.Open;
  PosT.FieldByName('KnoIncCost').OnChange := nil;
  PosT.FieldByName('KnoIncQuantity').OnChange := nil;
  MoneysT.Open;
  MoneysT.FieldByName('KnoIncSumm').OnChange := nil;
  CompanyC.DeActivate;
  CompanyC.Activate;
  if EditMode then begin
    OpenQueryWithParams(PosQ, SubReg.PathToSQL+'____IdKno.sql',
     [IntToStr(FIdKNO)]);
    SetFieldsReadOnly(PosT, ['Id','IdGoods','IdKNO'], false);
    CopyDataSetToDataSet(PosQ, PosT, MainForm.CopyProgress);
    SetFieldsReadOnly(PosT, ['Id','IdGoods','IdKNO'], true);

    OpenQueryWithParams(MoneysQ, SubReg.PathToSQL+'____IdKno.sql',
     [IntToStr(FIdKNO)]);
    SetFieldsReadOnly(MoneysT, ['Id','Fac_ID','KNO_ID'], false);
    CopyDataSetToDataSet(MoneysQ, MoneysT, MainForm.CopyProgress);
    SetFieldsReadOnly(MoneysT, ['Id','Fac_ID','KNO_ID'], true);

    TmpQuery := GetQuery(SubReg.PathToSQL+'___Id.sql', BaseDir, [IntToStr(FIdKNO)]);
    if TmpQuery <> nil then
     with TmpQuery do begin
       KnoNumberE.AsString := FieldByName('KnoNumber').AsString;
       KnoDateE.AsDate := FieldByName('KnoDate').AsDateTime;
       SummE.Value := FieldByName('KnoSumm').AsFloat;
       CompanyC.ItemId := FieldByName('IdCompany').AsInteger;
       TmpQuery.Free;
     end
    else ErrorMsg('    !');
  end
  else begin
    KnoNumberE.AsString := '';
    KnoDateE.AsDate := Date;
    SummE.Value := 0;
    CompanyC.ItemIndex := 0;
  end;
  PosT.FieldByName('KnoIncCost').OnChange := RecalcPosSumm;
  PosT.FieldByName('KnoIncQuantity').OnChange := RecalcPosSumm;
  MoneysT.FieldByName('KnoIncSumm').OnChange := RecalcMoneySumm;
  RecalcPosSumm(nil);
  RecalcMoneySumm(nil);
end;

procedure TKnoForm.SaveKNO;
var Success : boolean;
    Index : LongInt;
begin
  MainForm.DataBase.StartTransaction;
  try
    //   ,     
    for Index := 0 to pred(DelIds.Count) do begin
      Success := ExecuteSQL(SubReg.PathToSQL+'____Id.sql',
         BaseDir, [IntToStr(DelIds[Index])]);

      if not Success then begin
        MainForm.DataBase.RollBack;
        exit;
      end;
    end;

    for Index := 0 to pred(DelFactory.Count) do begin
      Success := ExecuteSQL(SubReg.PathToSQL+'____Id.sql',
         BaseDir, [IntToStr(DelFactory[Index])]);

      if not Success then begin
        MainForm.DataBase.RollBack;
        exit;
      end;
    end;

    //   ,     ,  Update
    //   ,    -  Insert
    with PosT do begin
      First;
      while not Eof do begin
        if AddedIds.IndexOf(FieldByName('Id').AsInteger)=-1 then
          Success := ExecuteSQL(SubReg.PathToSQL+'__.sql',
           BaseDir, [FieldByName('Id').AsString,
                     FloatToSQLFloat(FieldByName('KnoIncQuantity').AsFloat),
                     FloatToSQLFloat(FieldByName('KnoIncCost').AsFloat)])
        else
          Success := ExecuteSQL(SubReg.PathToSQL+'__.sql',
           BaseDir, [FieldByName('Id').AsString,
                     FieldByName('IdKno').AsString,
                     FloatToSQLFloat(FieldByName('KnoIncQuantity').AsFloat),
                     FloatToSQLFloat(FieldByName('KnoIncCost').AsFloat),
                     FieldByName('IdGoods').AsString
                    ]);
        if not Success then begin
          MainForm.DataBase.RollBack;
          exit;
        end;
        Next;
      end;
    end;

    with MoneysT do begin
      First;
      while not Eof do begin
        if AddedFactory.IndexOf(FieldByName('Id').AsInteger)=-1 then
          Success := ExecuteSQL(SubReg.PathToSQL+'__.sql',
           BaseDir, [FieldByName('Id').AsString,
                     FloatToSQLFloat(FieldByName('KnoIncSumm').AsFloat),
                     FieldByName('GoodsName').AsString
                    ])
        else
          Success := ExecuteSQL(SubReg.PathToSQL+'___.sql',
           BaseDir, [FieldByName('Id').AsString,
                     FieldByName('KNO_Id').AsString,
                     FieldByName('FAC_Id').AsString,
                     FloatToSQLFloat(FieldByName('KnoIncSumm').AsFloat),
                     FieldByName('GoodsName').AsString
                    ]);
        if not Success then begin
          MainForm.DataBase.RollBack;
          exit;
        end;
        Next;
      end;
    end;

    if EditMode then
      Success := ExecuteSQL(SubReg.PathToSQL+'_.sql',
       BaseDir, [IntToStr(FIdKno),
                 DateToSQLDate(KnoDateE.AsDate),
                 FloatToSQLFloat(SummE.Value),
                 KnoNumberE.AsString,
                 IntToStr(CompanyC.ItemId)
                ])
    else
      Success := ExecuteSQL(SubReg.PathToSQL+'_.sql',
       BaseDir, [IntToStr(FIdKno),
                 DateToSQLDate(KnoDateE.AsDate),
                 FloatToSQLFloat(SummE.Value),
                 KnoNumberE.AsString,
                 IntToStr(CompanyC.ItemId)
                ]);
    if not Success then begin
      MainForm.DataBase.RollBack;
      exit;
    end;
    MainForm.DataBase.Commit;
  except
    MainForm.DataBase.RollBack;
  end;
end;

function TKnoForm.EditKNO (IdKNO : LongInt) : boolean;
begin
  EditMode := true;
  FIdKno := IdKno;
  PrepareForm;
  Result := ShowModal = mrOk;
  if not Result then exit;
  SaveKNO;
end;

function TKnoForm.NewKNO : boolean;
begin
  EditMode := false;
  FIdKno := GetNewId('IBKno.New.Kno.');
  PrepareForm;
  Result := ShowModal = mrOk;
  if not Result then exit;
  SaveKNO;
end;

procedure TKnoForm.SetSummBClick(Sender: TObject);
begin
  SummE.Value := CurSummE.Value;
  RecalcPosSumm(nil);
end;

procedure TKnoForm.RecalcPosSumm (Sender :  TField);
var BkMark : TBookMark;
    S : Double;
begin
  if not PosT.Active then exit;
  with PosT do begin
    BkMark := GetBookMark;
    DisableControls;
    First;
    try
      S := 0;
      while not Eof do begin
        S := S + FieldByName('KnoIncCost').AsFloat *
                 FieldByName('KnoIncQuantity').AsFloat;
        Next;
      end;
      PosSummE.Value := S;
      CurSummE.Value := S + MoneysSummE.Value;
      RemainE.Value := SummE.Value - CurSummE.Value;
    finally
      GotoBookMark(BkMark);
      FreeBookMark(BkMark);
      EnableControls;
    end;
  end;
end;

procedure TKnoForm.RecalcMoneySumm (Sender :  TField);
var BkMark : TBookMark;
    S : Double;
begin
  if not MoneysT.Active then exit;
  with MoneysT do begin
    BkMark := GetBookMark;
    DisableControls;
    First;
    try
      S := 0;
      while not Eof do begin
        S := S + FieldByName('KnoIncSumm').AsFloat;
        Next;
      end;
      MoneysSummE.Value := S;
      CurSummE.Value := S + PosSummE.Value;
      RemainE.Value := SummE.Value - CurSummE.Value;
    finally
      GotoBookMark(BkMark);
      FreeBookMark(BkMark);
      EnableControls;
    end;
  end;
end;

procedure TKnoForm.FormCreate(Sender: TObject);
begin
  if Ini.ReadBool('Options', 'ShowBack', true) then begin
    Back.FillMode := TBitmapFillMode(Ini.ReadInteger('Options','KnoFillMode',ord(fmTiles)));
    Back.FileName := SubReg.PathToImages + Ini.ReadString('Options','KnoBack','KnoBack.gif');
  end;
  PosT.DataBaseName := SubReg.PathToProgram+'TempTables\';
  MoneysT.DataBaseName := PosT.DataBaseName;
  AddedIds := TsohoIntegerList.Create;
  AddedFactory := TsohoIntegerList.Create;
  DelIds  := TsohoIntegerList.Create;
  DelFactory := TsohoIntegerList.Create;
end;

function TKnoForm.InsertNewPos : boolean;
var Index, NewGoodsId : LongInt;

    function AddOneRecord (IdGoods : LongInt) : boolean;
    var TmpQuery : TQuery;
        NewPosId : LongInt;
    begin
      TmpQuery := GetQuery(SubReg.PathToSQL+'___Id.sql',
        BaseDir, [IntToStr(IdGoods)]);
      if TmpQuery = nil then exit;
      SetFieldsReadOnly(PosT, ['Id','IdGoods','IdKNO'], false);
      with PosT do begin
        Append;
        FieldByName('KnoIncCost').OnChange := nil;
        FieldByName('KnoIncQuantity').OnChange := nil;
        NewPosId := GetNewId('IBKno.New.KnoInclude.Item.');
        FieldByName('Id').AsInteger := NewPosId;
        FieldByName('IdGoods').AsInteger := IdGoods;
        FieldByName('IdKNO').AsInteger := FIdKNO;
        FieldByName('GoodsName').AsString := TmpQuery.FieldByName('Name').AsString;
        FieldByName('UnitsName').AsString := TmpQuery.FieldByName('ChUnits').AsString;
        FieldByName('KnoIncCost').AsFloat := 0;
        FieldByName('KnoIncQuantity').AsFloat := 0;
        Post;
        FieldByName('KnoIncCost').OnChange := RecalcPosSumm;
        FieldByName('KnoIncQuantity').OnChange := RecalcPosSumm;
      end;
      AddedIds.Add(NewPosId);
      TmpQuery.Free;
      SetFieldsReadOnly(PosT, ['Id','IdGoods','IdKNO'], true);
    end;

begin
  Result := false;
  NewGoodsId := MainForm.GetGoods;
  if NewGoodsId=-1 then exit;
  try
    PosFolder.SaveDBGridColumns;
    PosT.DisableControls;
    if MainForm.GoodsTV.Results.Count>0 then
      for Index := 0 to pred(MainForm.GoodsTV.Results.Count) do
        AddOneRecord(MainForm.GoodsTV.Results.Items[Index])
    else AddOneRecord(NewGoodsId);
  finally
    PosT.EnableControls;
    PosFolder.LoadDBGridColumns;
  end;
  Result := true;
end;

function TKnoForm.PosGridOperation(Sender: TObject;
  Operation: TsohoGridOperation): Boolean;
var Id : LongInt;
begin
  case Operation of
    soNewRecord    : InsertNewPos;
    soDeleteRecord : begin
      if not YesNoMsg(' ,     ?') then exit;
      Id := PosT.FieldByName('Id').AsInteger;
      PosT.Delete;
      DelIds.Add(Id);
      AddedIds.Remove(Id);
    end;
  end;
end;

function TKnoForm.InsertNewFactory : boolean;
var Index, NewFactoryId : LongInt;

    function AddOneRecord (IdFactory : LongInt) : boolean;
    var TmpQuery : TQuery;
        NewFacId : LongInt;
    begin
      TmpQuery := GetQuery(SubReg.PathToSQL+'___Id.sql',
        BaseDir, [IntToStr(IdFactory)]);
      if TmpQuery = nil then exit;
      SetFieldsReadOnly(MoneysT, ['Id','Fac_ID','KNO_ID'], false);
      with MoneysT do begin
        Append;
        FieldByName('KnoIncSumm').OnChange := nil;
        NewFacId := GetNewId('IBKno.New.KnoAssessment.Item.');
        FieldByName('Id').AsInteger := NewFacId;
        FieldByName('Fac_ID').AsInteger := IdFactory;
        FieldByName('FactoryName').AsString := TmpQuery.FieldByName('Name').AsString;
        FieldByName('KNO_ID').AsInteger := FIdKNO;
        Post;
        FieldByName('KnoIncSumm').OnChange := RecalcMoneySumm;
      end;
      AddedFactory.Add(NewFacId);
      TmpQuery.Free;
      SetFieldsReadOnly(MoneysT, ['Id','Fac_ID','KNO_ID'], true);
    end;

begin
  Result := false;
  if not MainForm.FactoryTV.Execute(false, true, true) then exit;
  NewFactoryId := MainForm.FactoryTV.ItemId;
  if NewFactoryId=-1 then exit;
  try
    MoneyFolder.SaveDBGridColumns;
    MoneysT.DisableControls;
    if MainForm.FactoryTV.Results.Count>0 then
      for Index := 0 to pred(MainForm.FactoryTV.Results.Count) do
        AddOneRecord(MainForm.FactoryTV.Results.Items[Index])
    else AddOneRecord(NewFactoryId);
  finally
    MoneysT.EnableControls;
    MoneyFolder.LoadDBGridColumns;
  end;
  Result := true;
end;

function TKnoForm.MoneyGridOperation(Sender: TObject;
  Operation: TsohoGridOperation): Boolean;
var Id : LongInt;
begin
  case Operation of
    soNewRecord    : InsertNewFactory;
    soDeleteRecord : begin
      if not YesNoMsg(' ,     ?') then exit;
      Id := MoneysT.FieldByName('Id').AsInteger;
      MoneysT.Delete;
      AddedFactory.Remove(Id);
      DelFactory.Add(Id);
    end;
  end;
end;

procedure TKnoForm.FormShow(Sender: TObject);
begin
  PageControl1.ActivePage := KNOPage;
  PageControl1.Update;
  KnoPage.Update;
end;

procedure TKnoForm.FormDestroy(Sender: TObject);
begin
  AddedIds.Free;
  AddedFactory.Free;
  DelIds.Free;
  DelFactory.Free;
end;

procedure TKnoForm.PrintBClick(Sender: TObject);
var aTemplate : string;
    aPrintAction : TsohoExcelPrintAction;
    aPrintToFile : boolean;
    aCopies : integer;
begin
  with Reporter do begin
    aTemplate := SelectTemplate(SubReg.PathToReports+'  \');
    if aTemplate = '' then exit;
    Template := aTemplate;
    SetValueByName('#',KnoDateE.AsString);
    SetValueByName('#',SysUtils.FloatToStrF(SummE.Value, ffNumber, 15, 3));
    SetValueByName('#',Trim(CompanyC.Text));

    aPrintAction := PrintAction;
    aPrintToFile := PrintToFile;
    aCopies      := PrintCopies;
    if PrintDialog then
      if not GetExcelReportOptions(aPrintAction, aPrintToFile, aCopies) then exit;

    PrintAction := aPrintAction;
    PrintToFile := aPrintToFile;
    PrintCopies := aCopies;
    SetCursor(crHourGlass);
    if OpenExcel then
      if PrintTitle then begin
        Folder := PosFolder;
        OnAfterTransfer := ReporterAfterTransfer;
        PrintTable;
      end;
  end;
end;

procedure TKnoForm.ReporterAfterTransfer(Sender: TObject;
  var Allow: Boolean);
begin
  // .   ,   Folder     
  //  ,    OnAfterTransfer  nil
  with Reporter do begin
    OnAfterTransfer := nil;
    Folder := MoneyFolder;
    Allow  := PrintTable;
  end;
end;

initialization
  KnoForm := nil;
end.
