unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, SoStatus, SohoHntC, SohoRgst, SoBckgrd, AppEvent, SoRxTls,
  Placemnt, Menus, SoAbout, SohoGuid, SoTVCont, DBTables, SoClass, SoDBGrid,
  SpeedBar, SoSpeed, RxGrdCpt, SoSumRep, SoCtmRgs;

type
  TMainForm = class(TForm)
    MainIni: TsohoFormStorage;
    App: TsohoApplication;
    Back: TsohoBackground;
    Register: TsohoRegister;
    Hints: TsohoHintsCollector;
    StatusBar: TsohoStatus;
    AboutBox: TsohoAboutBox;
    MainMenu: TMainMenu;
    CommonM: TMenuItem;
    OptionsM: TMenuItem;
    S1: TMenuItem;
    ExitM: TMenuItem;
    GuidesM: TMenuItem;
    DocumentsM: TMenuItem;
    AnalisM: TMenuItem;
    HelpM: TMenuItem;
    ContentsM: TMenuItem;
    S2: TMenuItem;
    AboutM: TMenuItem;
    FactoryM: TMenuItem;
    GoodsM: TMenuItem;
    CompanyM: TMenuItem;
    OrderM: TMenuItem;
    KnoM: TMenuItem;
    FactoryReportM: TMenuItem;
    KnoReportM: TMenuItem;
    S3: TMenuItem;
    PluginsM: TMenuItem;
    FactoryTV: TsohoTVContainer;
    CompanyTV: TsohoTVContainer;
    GoodsTV: TsohoTVContainer;
    KnoGuide: TsohoDBGuide;
    OrdersGuide: TsohoDBGuide;
    Database: TDatabase;
    Bevel1: TBevel;
    sohoSpeedBar1: TsohoSpeedBar;
    SpeedbarSection1: TSpeedbarSection;
    SpeedbarSection2: TSpeedbarSection;
    SpeedbarSection3: TSpeedbarSection;
    SpeedbarSection4: TSpeedbarSection;
    OptionsB: TSpeedItem;
    ExitB: TSpeedItem;
    FactoryB: TSpeedItem;
    GoodsB: TSpeedItem;
    CompanyB: TSpeedItem;
    KnoB: TSpeedItem;
    OrderB: TSpeedItem;
    FactoryReportB: TSpeedItem;
    KnoReportB: TSpeedItem;
    RxCaption: TRxGradientCaption;
    SummReport: TsohoSummReport;
    procedure RegisterActivate(Sender: TObject);
    procedure AboutMClick(Sender: TObject);
    procedure FactoryMClick(Sender: TObject);
    procedure GoodsMClick(Sender: TObject);
    procedure CompanyMClick(Sender: TObject);
    procedure ExitMClick(Sender: TObject);
    procedure GoodsTVItemEdit(Sender: TObject; GroupId, ItemID: Integer;
      var Allow: Boolean);
    procedure GoodsTVNewItem(Sender: TObject; GroupId: Integer; var ItemID,
      ItemHash: Integer; var Allow: Boolean);
    procedure OrderMClick(Sender: TObject);
    procedure KnoMClick(Sender: TObject);
    function KnoGuideOperation(Sender: TObject;
      Operation: TsohoGridOperation): Boolean;
    function OrdersGuideOperation(Sender: TObject;
      Operation: TsohoGridOperation): Boolean;
    procedure FactoryReportMClick(Sender: TObject);
    procedure KnoReportMClick(Sender: TObject);
    procedure BackPaint(Sender: TObject; Canvas: TCanvas);
  private
    { Private declarations }
  public
    { Public declarations }
    function GetGoods : LongInt;
    procedure CopyProgress (Sender : TObject; Stage : TProgressStage;
          PercentDone : byte; const Msg : string);
    function GetCompany : LongInt;
    function GetFactory (var Ids : TsohoIntegerList) : boolean;
  end;

var
  MainForm: TMainForm;

function GetFactoryName (IdFactory : LongInt) : string;

implementation
uses Global, SoUtils, GoodsF, KnoF, SoDBRtn, OrderF, FacRepF, SoVrsInf,
     FileUtil, SoCtrls, SoBDERtn;

{$R *.DFM}

function GetFactoryName (IdFactory : LongInt) : string;
begin
  Result := GetSQLResult(MainForm.Register.PathToSQL+
    '____Id.sql', BaseDir, [IntToStr(IdFactory)]);
end;

function TMainForm.GetCompany : LongInt;
begin
  Result := -1;
  if not CompanyTV.Execute(false, true, true) then exit;
  if CompanyTV.Results.Count>0 then Result := CompanyTV.Results.Items[0]
  else Result := CompanyTV.ItemId;
end;

function TMainForm.GetFactory (var Ids : TsohoIntegerList) : boolean;
begin
  //FactoryTV.OnFormCreate := FactoryGuideFormCreate;
  Result := FactoryTV.Execute(false, true, true);
  FactoryTV.Results.SaveToFile(Register.PathToProgram+'Lists\Kno\CurFactories.ids');
  Ids.LoadFromFile(Register.PathToProgram+'Lists\Kno\CurFactories.ids');
  FactoryTV.Results.Clear;
end;

procedure TMainForm.CopyProgress (Sender : TObject; Stage : TProgressStage;
          PercentDone : byte; const Msg : string);
begin
  if Stage = psStarting then StatusBar.Gauge.MaxValue := 100;
  StatusBar.Gauge.Progress := PercentDone;
  StatusBar.Gauge.Caption  := Msg;
end;

function TMainForm.GetGoods   : LongInt;
begin
  Result := -1;
  if not GoodsTV.Execute(false, true, true) then exit;
  if GoodsTV.Results.Count>0 then Result := GoodsTV.Results.Items[0]
  else Result := GoodsTV.ItemId;
end;

procedure TMainForm.RegisterActivate(Sender: TObject);
begin
  StatusBar.Gauge.ShowText := true;
  if MainIni.ReadBool('Options', 'ShowBack', true) then begin
    Back.FillMode := TBitmapFillMode(MainIni.ReadInteger('Options','MainFillMode',ord(fmStretch)));
    Back.FileName := Register.PathToImages + MainIni.ReadString('Options','MainBack','MainBack.gif');;
  end;
  try
    DataBase.AliasName := Register.PathToData;
    DataBase.Connected := true;
    BaseDir := 'IBKno_DataBase';
  except
    on E:Exception do begin
      ErrorMsg('     : '+E.Message);
      Application.Terminate;
    end;
  end;
  FactoryTV.Gauge   := StatusBar.Gauge;
  CompanyTV.Gauge   := StatusBar.Gauge;
  GoodsTV.Gauge     := StatusBar.Gauge;
  KnoGuide.Gauge    := StatusBar.Gauge;
  OrdersGuide.Gauge := StatusBar.Gauge;
end;

procedure TMainForm.AboutMClick(Sender: TObject);
begin
  AboutBox.Execute;
end;

procedure TMainForm.FactoryMClick(Sender: TObject);
begin
  FactoryTV.Execute(false, true, false);
end;

procedure TMainForm.GoodsMClick(Sender: TObject);
begin
  GoodsTV.Execute(false, true, false);
end;

procedure TMainForm.CompanyMClick(Sender: TObject);
begin
  CompanyTV.Execute(false, true, false);
end;

procedure TMainForm.ExitMClick(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.GoodsTVItemEdit(Sender: TObject; GroupId,
  ItemID: Integer; var Allow: Boolean);
begin
  Allow := EditGoods(ItemId);
end;

procedure TMainForm.GoodsTVNewItem(Sender: TObject; GroupId: Integer;
  var ItemID, ItemHash: Integer; var Allow: Boolean);
begin
  Allow := NewGoods(ItemId, GroupId, ItemHash);
end;

procedure TMainForm.OrderMClick(Sender: TObject);
begin
  OrdersGuide.Execute(false, true, false);
end;

procedure TMainForm.KnoMClick(Sender: TObject);
begin
  KnoGuide.Execute(false, true, false);
end;

function TMainForm.KnoGuideOperation(Sender: TObject;
  Operation: TsohoGridOperation): Boolean;
var DoRefresh : boolean;
begin
  case Operation of
    soNewRecord    : DoRefresh := NewKNO;
    soEditRecord   : DoRefresh := EditKNO(KnoGuide.ItemsQuery.FieldByName('Id').AsInteger);
    soDeleteRecord : begin
      DoRefresh := YesNoMsg(' ,     ?');
      if DoRefresh then
        DoRefresh := ExecuteSQL(Register.PathToSQL+'___Id.sql',
          BaseDir, [KnoGuide.ItemsQuery.FieldByName('Id').AsString]);
    end;
  end;
  if DoRefresh then begin
    RefreshFolder(KnoGuide.GuideForm.GuideFolder);
    if OrdersGuide.GuideForm <> nil then
      RefreshFolder(OrdersGuide.GuideForm.GuideFolder);
  end;
end;

function TMainForm.OrdersGuideOperation(Sender: TObject;
  Operation: TsohoGridOperation): Boolean;
var DoRefresh : boolean;
begin
  case Operation of
    soNewRecord    : DoRefresh := NewOrder;
    soEditRecord   : DoRefresh := EditOrder(OrdersGuide.ItemsQuery.FieldByName('Id').AsInteger);
    soDeleteRecord : begin
      DoRefresh := YesNoMsg(' ,     ?');
      if DoRefresh then
        DoRefresh := ExecuteSQL(Register.PathToSQL+'___Id.sql',
          BaseDir, [OrdersGuide.ItemsQuery.FieldByName('Id').AsString]);
    end;
  end;
  if DoRefresh then RefreshFolder(OrdersGuide.GuideForm.GuideFolder);
end;

procedure TMainForm.FactoryReportMClick(Sender: TObject);
var IdFactory : LongInt;
    IdKno : TsohoIntegerList;
    Index     : Longint;
    Ids, IdsA, IdsTmp, KnoNumbers : string;
    Query     : TQuery;
    FactoryName : string;
begin
  IdKno := TsohoIntegerList.Create;
  if not FactoryReportData (IdFactory, IdKno, true) then begin
    IdKno.Free;
    exit;
  end;
  Ids := '';
  IdsA := '';
  IdsTmp := '';
  for Index := 0 to pred(IdKno.Count) do begin
    Ids := Ids + '(IdKNO=' + IntToStr(IdKNO.Items[Index]) + ')';
    IdsA := IdsA + '(KNO_Id=' + IntToStr(IdKNO.Items[Index]) + ')';
    IdsTmp := IdsTmp + '(Id=' + IntToStr(IdKNO.Items[Index]) + ')';
    if Index <> pred(IdKno.Count) then begin
      Ids    := Ids + ' or ';
      IdsA   := IdsA + ' or ';
      IdsTmp := IdsTmp + ' or ';
    end;
  end;
  IdKno.Free;
  with SummReport do begin
    //OnCalcCellColors := ReportCalcCellColors;
    Gauge      := StatusBar.Gauge;
    FactoryName := GetFactoryName(IdFactory);
    Caption    := '  : '+FactoryName;
    FolderName := '__.ini';
    SQLFile    := '__.sql';
    DataBaseName := BaseDir;
    Reporter.Template := '  ';
    Reporter.ClearParams;
    Reporter.SetValueByName('#', FactoryName);

    Query := GetQuery(Register.PathToSQL+'__.sql',
             BaseDir, [IdsTmp]);
    if Query = nil then exit;
    KnoNumbers := '';
    with Query do begin
      while not Eof do begin
        KnoNumbers := KnoNumbers + FieldByName('KnoNumber').AsString;
        Next;
        if not Eof then KnoNumbers := KnoNumbers + ', ';
      end;
      Free;
    end;
    //      ,    
    //   .
    KnoNumbers := CutStringOnLines(KnoNumbers, 90);
    SetDivisers(['|']);
    Reporter.SetValueByName('#1', GetSomeWords(KnoNumbers,1,1));
    Reporter.SetValueByName('#2', GetSomeWords(KnoNumbers,2,2));
    Reporter.SetValueByName('#3', GetSomeWords(KnoNumbers,3,3));
    Execute([IntToStr(IdFactory), Ids, IntToStr(IdFactory), IdsA]);
  end;
end;

procedure TMainForm.KnoReportMClick(Sender: TObject);
var IdKno     : TsohoIntegerList;
    Index, IdFactory     : Longint;
    Ids, IdsTmp, IdsA, KnoNumbers : string;
    Query     : TQuery;
begin
  IdKno := TsohoIntegerList.Create;
  if not FactoryReportData(IdFactory, IdKNO, false) then begin
    IdKno.Free;
    exit;
  end;
  Ids := '';
  IdsA := '';
  IdsTmp := '';
  for Index := 0 to pred(IdKno.Count) do begin
    Ids := Ids + '(IdKNO=' + IntToStr(IdKNO.Items[Index]) + ')';
    IdsA := IdsA + '(KNO_ID=' + IntToStr(IdKNO.Items[Index]) + ')';
    IdsTmp := IdsTmp + '(Id=' + IntToStr(IdKNO.Items[Index]) + ')';
    if Index <> pred(IdKno.Count) then begin
      Ids    := Ids + ' or ';
      IdsA    := IdsA + ' or ';
      IdsTmp := IdsTmp + ' or ';
    end;
  end;
  IdKno.Free;
  with SummReport do begin
    //OnCalcCellColors := ReportCalcCellColors;
    Gauge      := StatusBar.Gauge;
    FolderName := '__.ini';
    SQLFile    := '__.sql';
    DataBaseName := BaseDir;
    Reporter.Template := '  ';
    Reporter.ClearParams;
    KnoNumbers := '';
    Query := GetQuery(Register.PathToSQL+'__.sql', BaseDir,
       [IdsTmp]);
    if Query = nil then exit;
    with Query do begin
      while not Eof do begin
        KnoNumbers := KnoNumbers + FieldByName('KnoNumber').AsString;
        Next;
        if not Eof then KnoNumbers := KnoNumbers + ', ';
      end;
      Free;
    end;
    Caption    := '  : '+KnoNumbers;
    KnoNumbers := CutStringOnLines(KnoNumbers, 90);
    SetDivisers(['|']);
    Reporter.SetValueByName('#1', GetSomeWords(KnoNumbers,1,1));
    Reporter.SetValueByName('#2', GetSomeWords(KnoNumbers,2,2));
    Reporter.SetValueByName('#3', GetSomeWords(KnoNumbers,3,3));
    Execute([Ids, IdsA]);
  end;
end;

procedure TMainForm.BackPaint(Sender: TObject; Canvas: TCanvas);
var Tmp : string;
    Rect : TRect;
begin
  Tmp := 'Beta-version. Build #'+GetFileVersion+'  '+ DateTimeToStr(
    FileDateTime(Application.ExeName));
  with Canvas do begin
    Font := Self.Font;
    Font.Size := 10;
    Font.Color := clAqua;
    Font.Style := [fsBold];
    Brush.Style := bsClear;
    with Rect do begin
      Left := ClientWidth - TextWidth(Tmp)-5;
      Top := ClientHeight - TextHeight(Tmp)-5-StatusBar.Height;
      Right := Left + TextWidth(Tmp);
      Bottom := Top + TextHeight(Tmp);
    end;
    Draw3DText(Tmp, Rect, Canvas, lpLeftTop, clBtnFace, clWhite, clBlack, 1,
               taLeftJustify, false, false, false);
  end;
end;

end.
