unit ProjForm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, SohoBtns, SoCtrls, SoTVCont;

type
  TProjectForm = class(TForm)
    sohoLabel1: TsohoLabel;
    sohoLabel2: TsohoLabel;
    NameE: TsohoEdit;
    CustomerE: TsohoEdit;
    OkB: TsohoBitBtn;
    CancelB: TsohoBitBtn;
    sohoLabel3: TsohoLabel;
    sohoLabel4: TsohoLabel;
    BegDateE: TsohoEdit;
    EndDateE: TsohoEdit;
    DoneC: TCheckBox;
    PayedC: TCheckBox;
    sohoLabel5: TsohoLabel;
    CommentE: TsohoEdit;
    PersonsTV: TsohoTVContainer;
    procedure CustomerERightClick(Sender: TObject);
    procedure OkBClick(Sender: TObject);
    procedure DoneCClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    IdCustomer : LongInt;
  end;

var ProjectForm: TProjectForm;

function EditProject (var aName, aCustomer : string; var aIdCustomer : LongInt;
         var aBegDate, aEndDate : TDateTime; var aDone, aPayed : boolean;
         var aComment : string) : boolean;
function NewProject (var aName, aCustomer : string; var aIdCustomer : LongInt;
         var aBegDate, aEndDate : TDateTime; var aDone, aPayed : boolean;
         var aComment : string) : boolean;

implementation
uses SoDBRtn, SoDate, SohoRgst, SoBDERtn, SoCtmRgs;

{$R *.DFM}

function Execute(var aName, aCustomer : string; var aIdCustomer : LongInt;
         var aBegDate, aEndDate : TDateTime; var aDone, aPayed : boolean;
         var aComment : string) : boolean;
begin
  Result := false;
  if ProjectForm.ShowModal <> mrOk then exit;
  with ProjectForm do begin
     Result    := true;
     aName     := NameE.AsString;
     aCustomer := CustomerE.AsString;
     aBegDate  := BegDateE.AsDate;
     aEndDate  := EndDateE.AsDate;
     aDone     := DoneC.Checked;
     aPayed    := PayedC.Checked;
     aComment  := CommentE.AsString;
     aIdCustomer := IdCustomer;
  end;
end;

function EditProject (var aName, aCustomer : string; var aIdCustomer : LongInt;
         var aBegDate, aEndDate : TDateTime; var aDone, aPayed : boolean;
         var aComment : string) : boolean;
begin
   try
     Result := false;
     ProjectForm := TProjectForm.Create(Application);
     with ProjectForm do begin
       IdCustomer := aIdCustomer;
       NameE.AsString := aName;
       CustomerE.AsString := aCustomer;
       BegDateE.AsDate := aBegDate;
       EndDateE.AsDate := aEndDate;
       DoneC.Checked   := aDone;
       PayedC.Checked  := aPayed;
       IdCustomer      := aIdCustomer;
       CommentE.AsString := aComment;
     end;
     Result := Execute(aName, aCustomer, aIdCustomer, aBegDate,
       aEndDate, aDone, aPayed, aComment);
   finally
     ProjectForm.Free;
   end;
end;

function NewProject (var aName, aCustomer : string; var aIdCustomer : LongInt;
         var aBegDate, aEndDate : TDateTime; var aDone, aPayed : boolean;
         var aComment : string) : boolean;
begin
   try
     Result := false;
     ProjectForm := TProjectForm.Create(Application);
     ProjectForm.IdCustomer := -1;
     Result := Execute(aName, aCustomer, aIdCustomer, aBegDate, aEndDate,
       aDone, aPayed, aComment);
   finally
     ProjectForm.Free;
   end;
end;

procedure TProjectForm.CustomerERightClick(Sender: TObject);
begin
  if PersonsTV.ReCreateExecute(true, true) then begin
    IdCustomer := PersonsTV.ItemId;
    CustomerE.AsString := GetSQLResult(SingleRegister.PathToSQL+'PERSNAME.SQL',
      PersonsTV.DataBaseName, [IntToStr(IdCustomer)]);
  end;
end;

procedure TProjectForm.OkBClick(Sender: TObject);
begin
   if IdCustomer=-1 then begin
     CustomerE.SetFocus;
     exit;
   end;
   ModalResult := mrOk;
end;

procedure TProjectForm.DoneCClick(Sender: TObject);
begin
   if DoneC.Checked then
    if IsNullDate(EndDateE.AsString) then EndDateE.AsDate := Date
    else
   else EndDateE.Text := '';
end;

end.
