{*******************************************************}
{                                                       }
{           Delphi Visual Component Library             }
{                                                       }
{          Copyright (c) 1996-1997 AllexSoft            }
{                   Written by VSM                      }
{                                                       }
{                   SOHO Components                     }
{                                                       }
{*******************************************************}
unit SoCommCtrl;

{$I SOHOLIB.INC}

interface
uses CommCtrl, Windows, Graphics;

const
  ICC_LISTVIEW_CLASSES = $00000001; // listview, header
  ICC_TREEVIEW_CLASSES = $00000002; // treeview, tooltips
  ICC_BAR_CLASSES      = $00000004; // toolbar, statusbar, trackbar, tooltips
  ICC_TAB_CLASSES      = $00000008; // tab, tooltips
  ICC_UPDOWN_CLASS     = $00000010; // updown
  ICC_PROGRESS_CLASS   = $00000020; // progress
  ICC_HOTKEY_CLASS     = $00000040; // hotkey
  ICC_ANIMATE_CLASS    = $00000080; // animate
  ICC_WIN95_CLASSES    = $000000FF;
  ICC_DATE_CLASSES     = $00000100; // month picker, date picker, time picker, updown
  ICC_USEREX_CLASSES   = $00000200; // comboex
  ICC_COOL_CLASSES     = $00000400; // rebar (coolbar) control

const
  TVS_TRACKSELECT = $0200;

  LVCF_IMAGE              = $0010;
  LVCF_ORDER              = $0020;

  LVCFMT_LEFT             = $0000;
  LVCFMT_RIGHT            = $0001;
  LVCFMT_CENTER           = $0002;
  LVCFMT_JUSTIFYMASK      = $0003;
  LVCFMT_IMAGE            = $0800;
  LVCFMT_BITMAP_ON_RIGHT  = $1000;
  LVCFMT_COL_HAS_IMAGES   = $8000;

type
  TNMCUSTOMDRAW = record
    hdr: TNMHDR;
    dwDrawStage: DWORD;
    hdc: HDC;
    rc: TRect;
    dwItemSpec: Longint;  // this is control specific, but it's how to specify an item.  valid only with CDDS_ITEM bit set
    uItemState: UINT;
    lItemlParam: DWORD;
  end;

  TNMTVCUSTOMDRAW = record
    nmcd: TNMCUSTOMDRAW;
    clrText: TColor;
    clrTextBk: TColor;
  end;

  TNMLVCUSTOMDRAW = record
    nmcd: TNMCUSTOMDRAW;
    clrText: TColor;
    clrTextBk: TColor;
  end;

  PSohoLVCOLUMN = ^TsohoLVCOLUMN;
  TsohoLVCOLUMN = packed record
    mask: UINT;
    fmt: Integer;
    cx: Integer;
    pszText: PAnsiChar;
    cchTextMax: Integer;
    iSubItem: Integer;
    iImage: Integer;
    iOrder: Integer;
  end;

const
  NM_FIRST = 0-  0;       // generic to all controls
  NM_CUSTOMDRAW = NM_FIRST-12;

// custom draw return flags
// values under = $00010000 are reserved for global custom draw values.
// above that are for specific controls
  CDRF_DODEFAULT          = $00000000;
  CDRF_NEWFONT            = $00000002;
  CDRF_SKIPDEFAULT        = $00000004;


  CDRF_NOTIFYPOSTPAINT    = $00000010;
  CDRF_NOTIFYITEMDRAW     = $00000020;
  CDRF_NOTIFYPOSTERASE    = $00000040;
  CDRF_NOTIFYITEMERASE    = $00000080;

// drawstage flags
// values under = $00010000 are reserved for global custom draw values.
// above that are for specific controls
  CDDS_PREPAINT           = $00000001;
  CDDS_POSTPAINT          = $00000002;
  CDDS_PREERASE           = $00000003;
  CDDS_POSTERASE          = $00000004;
// the = $000010000 bit means it's individual item specific
  CDDS_ITEM               = $00010000;
  CDDS_ITEMPREPAINT       = CDDS_ITEM or CDDS_PREPAINT;
  CDDS_ITEMPOSTPAINT      = CDDS_ITEM or CDDS_POSTPAINT;
  CDDS_ITEMPREERASE       = CDDS_ITEM or CDDS_PREERASE;
  CDDS_ITEMPOSTERASE      = CDDS_ITEM or CDDS_POSTERASE;

implementation

end.
