{*******************************************************}
{                                                       }
{           Delphi Visual Component Library             }
{                                                       }
{          Copyright (c) 1996-1997 AllexSoft            }
{                 Written by VSM ,Allex                 }
{                                                       }
{                   SOHO Components                     }
{                                                       }
{*******************************************************}
{
      TsohoBitmapGraphic  TsohoBitmap,
     .
      , 
   Marat Sadykov (msadykov@mail.zarech.ru)
    RU.DELPHI
}
unit SoGraph;


{$I SOHOLIB.INC}
{$R-}

interface
uses Windows, Graphics, Classes;

(*
   -   (),       
  Bitmap ,          Canvas 

   
      variables,prorerties,procedures and functions:
     1.   ,    -  
     2.     ,    Bitmap    ,
             
     3.      
     4.   ()
*)


  type

     PArray = ^TArray;
     TArray = array [0..0] of LongInt;

     PsohoBitmapArray = ^TsohoBitmapArray;
     TsohoBitmapArray = record
       Left, Top, Width, Height : LongInt;
       Size : LongInt;
       Buffer : PArray;
     end;

     TsohoBitmapGraphic = class(TBitmap)
     private
       FCurrent : TsohoBitmapArray;
       FUpdating : boolean;
       // FParentHandle : HDC;
       FBitsInfo : TBitmapInfo;
     protected
       procedure SetQuickPixel (X,Y: integer; aColor : TColor);
       function  GetQuickPixel (X,Y: integer) : TColor;
     public
       constructor Create;override;
       destructor Destroy;override;
       {     }
       procedure UpdateBitmap;
       {     }
       procedure UpdateArea;
       {    "" }
       procedure BeginUpdate;
       {  }
       procedure EndUpdate;
       {    }
       function SetCurrentArea (aLeft, aTop, aWidth, aHeight : integer) : boolean;
       {      }
       procedure Assign(Source : TPersistent);override;
       {    }
       property QuickPixels  [X, Y: integer]: TColor read GetQuickPixel write SetQuickPixel;
       {      ""  }
       property CurrentArea : TsohoBitmapArray read FCurrent write FCurrent;
       // property ParentHandle : HDC read FParentHandle write FParentHandle;
     end;


     {TsohoBitmap = class(TGraphicControl)
     private
       FGraphic
     protected
     public
     published
     end;}

procedure InternalGetDIBits(ParentDC : HDC; Bitmap: TBitmap; var BitsInfo : TBitmapInfo;
          var Area : TsohoBitmapArray);
function  InternalSetDIBits(ParentDC : HDC; Bitmap: TBitmap;
          var BitsInfo : TBitmapInfo; Area: TsohoBitmapArray): integer;

implementation
uses SysUtils, SoUtils;


procedure InternalGetDIBits(ParentDC : HDC; Bitmap: TBitmap; var BitsInfo : TBitmapInfo;
          var Area : TsohoBitmapArray);

  function WidthBytes(I: Longint): Longint;
  begin
     Result := ((I + 31) div 32) * 4; //+31etc=  
  end;

begin
  with BitsInfo.bmiHeader do begin
    biWidth  := Bitmap.Width;
    biHeight := Bitmap.Height;
    biSize   :=  SizeOf(TBITMAPINFOHEADER);
    biCompression := BI_RGB;
    biBitCount  := 32;
    biPlanes := 1;
    biSizeImage := WidthBytes(biWidth * biBitCount) * biHeight;
    // Area.Buffer := AllocMem(biSizeImage);
  end;
  with Bitmap do begin
     GetDIBits(ParentDC, Handle, 0, Height, Area.Buffer , BitsInfo,
       DIB_RGB_COLORS);
  end;
end;

function InternalSetDIBits(ParentDC : HDC; Bitmap: TBitmap;
         var BitsInfo : TBitmapInfo; Area: TsohoBitmapArray): integer;
begin
  with Bitmap do begin
    Height := BitsInfo.bmiHeader.biHeight;
    Width  := BitsInfo.bmiHeader.biWidth;
    Result := SetDIBits(ParentDC, Handle, 0, Height, Area.Buffer,
              BitsInfo, DIB_RGB_COLORS);
  end;
end;

procedure TsohoBitmapGraphic.UpdateBitmap;
var TmpArea : TsohoBitmapArray;
    Index: LongInt;
    DC : HDC;
begin
  if not Assigned(FCurrent.Buffer) then exit;
  DC := GetDC(0);
  if   (FCurrent.Left = 0) and (FCurrent.Top = 0)
   and (FCurrent.Height = Height) and (FCurrent.Width = Width) then
     InternalSetDIBits(DC{ParentHandle}, Self, FBitsInfo, FCurrent)
  else begin
    TmpArea.Left := 0;
    TmpArea.Top := 0;
    TmpArea.Height := Height;
    TmpArea.Width := Width;
    TmpArea.Size := Height * Width * 4;
    TmpArea.Buffer := AllocMem(TmpArea.Size);
    InternalGetDIBits(DC{ParentHandle}, Self, FBitsInfo, TmpArea);
    for Index := 0 to pred(FCurrent.Height) do
      Move( FCurrent.Buffer^[Index*FCurrent.Width],
            TmpArea.Buffer^[(Index+FCurrent.Top)*Width+FCurrent.Left],
            FCurrent.Width * 4);
    InternalSetDIBits(DC{ParentHandle}, Self, FBitsInfo, TmpArea);
    FreeMem(TmpArea.Buffer, TmpArea.Size);
  end;
  ReleaseDC(0, DC);
end;

procedure TsohoBitmapGraphic.UpdateArea;
var TmpArea : TsohoBitmapArray;
    Index: LongInt;
    DC : HDC;
begin
  if Handle = 0 then exit;
  if not Assigned(FCurrent.Buffer) then exit;
  DC := GetDC(0);
  if   (FCurrent.Left = 0) and (FCurrent.Top = 0)
   and (FCurrent.Height = Height) and (FCurrent.Width = Width) then
     InternalGetDIBits(DC{ParentHandle}, Self, FBitsInfo, FCurrent)
  else begin
    TmpArea.Left := 0;
    TmpArea.Top := 0;
    TmpArea.Height := Height;
    TmpArea.Width := Width;
    TmpArea.Size := Height * Width * 4;
    TmpArea.Buffer := AllocMem(TmpArea.Size);
    InternalGetDIBits(DC{ParentHandle}, Self, FBitsInfo, TmpArea);
    for Index := 0 to pred(FCurrent.Height) do
      Move( TmpArea.Buffer^[(Index+FCurrent.Top)*Width+FCurrent.Left],
            FCurrent.Buffer^[Index*FCurrent.Width],
            FCurrent.Width * 4);
    FreeMem(TmpArea.Buffer, TmpArea.Size);
  end;
  ReleaseDC(0, DC);
end;

procedure TsohoBitmapGraphic.SetQuickPixel (X,Y: integer; aColor : TColor);
begin
  if not Assigned(FCurrent.Buffer) then exit;
  if (X < 0) or (X >= Width) or (Y < 0)  or (Y >= Height) then exit;
  with FCurrent do begin
   Y := Height - Y - 1;
   Buffer^[Y*Width + X] := aColor//ColorToRGB(aColor);
  end;
  if not FUpdating then UpdateBitmap;
end;

function  TsohoBitmapGraphic.GetQuickPixel (X,Y: integer) : TColor;
begin
  Result := clBlack;
  if not Assigned(FCurrent.Buffer) then exit;
  if (X < 0) or (X >= Width) or (Y < 0)  or (Y >= Height) then exit;
  with FCurrent do begin
   Y := Height - Y - 1;
   Result := Buffer^[Y*Width + X];
  end;
end;

constructor TsohoBitmapGraphic.Create;
begin
  inherited Create;
  FCurrent.Buffer  := nil;
  FUpdating := false;
end;

destructor TsohoBitmapGraphic.Destroy;
begin
  if Assigned(FCurrent.Buffer) then FreeMem(FCurrent.Buffer, FCurrent.Size);
  inherited Destroy;
end;

procedure TsohoBitmapGraphic.BeginUpdate;
begin
  FUpdating := true;
end;

procedure TsohoBitmapGraphic.EndUpdate;
begin
  FUpdating := false;
  UpdateBitmap;
end;

function TsohoBitmapGraphic.SetCurrentArea (aLeft, aTop, aWidth, aHeight : integer) : boolean;
begin
  Result := false;
  if Handle = 0 then exit;
  if Assigned(FCurrent.Buffer) then FreeMem(FCurrent.Buffer, FCurrent.Size);
  with FCurrent do begin
    Width  := aWidth;
    Height := aHeight;
    Left   := aLeft;
    Top    := aTop;
    Size   := Width * Height * 4;
    try
      Buffer := AllocMem(Size);
      Result := true;
    except
      exit;
    end;
  end;
  UpdateArea;
end;

procedure TsohoBitmapGraphic.Assign(Source : TPersistent);
begin
  inherited Assign(Source);
  if not (Source is TsohoBitmapGraphic) then
    raise Exception.Create('Source is not TsohoBitmapGraphic!');
  if Assigned(FCurrent.Buffer) then FreeMem(FCurrent.Buffer, FCurrent.Size);
  FCurrent.Buffer := nil;
  if TsohoBitmapGraphic(Source).FCurrent.Buffer = nil then exit; 
  FCurrent := TsohoBitmapGraphic(Source).FCurrent;
  FCurrent.Buffer := AllocMem(FCurrent.Size);
  Move(TsohoBitmapGraphic(Source).FCurrent.Buffer^,
    FCurrent.Buffer^, FCurrent.Size);
end;

initialization
  RegisterClasses([TsohoBitmapGraphic]);
  TPicture.RegisterFileFormat('qbmp', 'Quick Bitmap', TsohoBitmapGraphic);
finalization
  TPicture.UnRegisterGraphicClass(TsohoBitmapGraphic);
end.
